########################################################
#
#  Script ph_SetGlobalVal_V2_3.py
#
#  Cree le 09/12/2003.
#
#  #### USAGE ###################################
#  #
#  # Demmarer le script (ALT P ou File-Run),
#  # creer 2 nouveaux Group
#  # nommes "SelectedVerts" et "preSelectedVerts",
#  # en appuyant sur le bouton "CreateSelGroup",
#  # apres avoir bien-sur selectionne votre objet.
#  #
#  # Ensuite selectionnez vos vertex en mode edit
#  # et assignez les au Group "SelectedVerts",
#  # puis repassez en mode Object.
#  #
#  # Vous pouvez maintenant attribuer des valeurs globale
#  # a votre selection de vertices.
#  #
#  # Ce script vous permettra aussi de realigner vos
#  # vertices selectionnes sur un des points (au choix)
#  # de votre selection.
#  #
#  # Je pense qu'apres quelques essais, vous aurez vite
#  # compris comment fonctionne le script.
#  #
#  # PS(1):
#  # Le Group "SelectedVerts" est purge a chaque appui
#  # sur le bouton "Apply", d'ou le Group "preSelectedVerts"
#  # pour recuperer la selection precedente au cas ou...
#  #
#  # PS(2):
#  # Python ne supprime pas vraiment les objets,
#  # c'est pourquoi apres utilisation du script
#  # vous risquez de voir dans la fenetre "OOPS"
#  # des objets nommes "dust..." (si vous avez active le bouton
#  # "Scene data").
#  # Pas de panique (ces objets peuvent etre en nombres considerable),
#  # pour purger la fenetre il vous suffit de faire une sauvegarde
#  # et puis 'Reopen last', et la oh miracle, tout devient 'clean' !!!
#  #
#  ##########################
#
#
#  N'hesitez pas a m'envoyer vos commentaires si le coeur
#  vous en dit.
#
#  coolphil@worldonline.fr
#  
####################################

import Blender
from Blender import *
from Blender.Draw import *
from Blender.BGL import *

######################

SelectVertices = []
preSelectVertices = []
LocVerticesCo = []
GloVerticesCo = []
InitGloVerticesCo = []
InitLocVerticesCo = []
PrintedIndex = []

warn = 0
warn2 = 0
notObj = 0
ecran = 0
OkGo = "Do not go"
ApplyToX = 0
ApplyToY = 0
ApplyToZ = 0

Offset = Create(0)
AxeX = Create(0)
AxeY = Create(0)
AxeZ = Create(0)
SlidGlobVal = Create(0.0)
lstep=Create(10)
PointAxeX = Create(1)
PointAxeY = Create(0)
PointAxeZ = Create(0)
SlidFromPoint = Create(0)


BL_VERSION = Blender.Get('version')
if (BL_VERSION<=223):
    import Blender210
  
#############################################################
# SUBS from LOCAL to GLOBAL coordinates                     #
#############################################################

def GlobalPosition(P, Obj):
    #
    # Prend les coordonnees locale d'un point (Vertice from Mesh)
    # Et les transforme en coordonnees global
    #
    if (BL_VERSION<=223):
        m = Obj.matrix
    else:
        m = Obj.getMatrix()

    PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
    PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
    PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
    return [PX, PY, PZ]

def LocalPosition(P, Obj):
    #
    # Prend les coordonnees global d'un point
    # Et les transforme en coordonnees locale  (Vertice from Mesh)
    #
    if (BL_VERSION<=223):
        m = Blender210.getObject(Obj.name).inverseMatrix
    else:
        m = Obj.getInverseMatrix()

    PX = P[0]*m[0][0] + P[1]*m[1][0] + P[2]*m[2][0] + m[3][0]
    PY = P[0]*m[0][1] + P[1]*m[1][1] + P[2]*m[2][1] + m[3][1]
    PZ = P[0]*m[0][2] + P[1]*m[1][2] + P[2]*m[2][2] + m[3][2]
    return (PX, PY, PZ)

######################
######################
def InfoObj():       #
                     #
######################
    global notObj

    Obj = Object.GetSelected()[0]
    if Obj.getType() == 'Mesh':
        mename = Obj.getData().name
        me = Obj.getData()
        notObj = 0
        return (Obj,mename,me)
    else:
        #print "Not a Mesh object"
        notObj = 1
        return (notObj,0,0)


######################
######################
def PrintIndex(sel,globco,obj,me):
                     #
######################
    listobj = []
    scene = Scene.GetCurrent()

    count = 0
    for ind in sel:

        listobj.append(Object.New('Armature',str(ind)))

        listobj[count].LocX = globco[count][0]
        listobj[count].LocY = globco[count][1]
        listobj[count].LocZ = globco[count][2]
        listobj[count].setDrawType(8)

        scene.link(listobj[count])
        count += 1

    scene.update(0)
    Blender.Window.RedrawAll()

    return listobj

######################
######################
def DeleteObj(ListObject):
                     #
######################

  Curscene = Scene.GetCurrent()
  Curscenename = Curscene.name
  print Curscenename

  checknewscene = 0

  allscenes = Scene.Get()
  for f in allscenes:
      if f.name == 'dust-bin':
          checknewscene = 1

  if checknewscene == 0:
      newscene = Scene.New('dust-bin')     # create a new scene
  else:
      newscene = Scene.Get('dust-bin')


  objets = Object.GetSelected()
  if ListObject != []:
      for f in ListObject:
          Curscene.unlink(f)               # Unlink object to scene
          newscene.link(f)                 # link object to scene
          temp = f.name
          f.setName("dust"+temp)

      Curscene.makeCurrent()               # make this the current scene



  scene2delete = newscene

  Scene.Unlink(scene2delete)

  Curscene.update(1)
  Blender.Window.RedrawAll()

######################
######################
def CreateSelGroup():#
                     #
######################
      global notObj, preSelectVertices, SelectVertices, object, meshname, mesh


      checkSel = 0
      checkPre = 0

      ListGroup = mesh.getVertGroupNames()
      LenGroups = len(ListGroup)
      print "Nombre de groupe = ", LenGroups
      for f in range(0,len(ListGroup)):
        if ListGroup[f] == "SelectedVerts":
          checkSel = 1
          try:
              SelectVertices = mesh.getVertsFromGroup('SelectedVerts',0)
          except:
              pass


        if ListGroup[f] == "preSelectedVerts":
          checkPre = 1
          try:
              preSelectVertices = mesh.getVertsFromGroup('preSelectedVerts',0)
          except:
              pass

      if checkPre == 0:
        mesh.addVertGroup("preSelectedVerts")
      if checkSel == 0:
        mesh.addVertGroup("SelectedVerts")

      if len(preSelectVertices) == 0:
        emptySel = 1
      if len(SelectVertices) == 0:
        emptySel = 2
      else:
        emptySel = 0

      #print 
      #print "Dans CreateSelGroup(), emptySel =", emptySel

      return emptySel

######################
######################
def InitialCoFromSelIndx(sel,meshObj,Obj):
                     #
######################
    LocVertsCo = []
    GloVertsCo = []
    TempGlob = []
    compt = 0
    for f in sel:
        LocVertsCo.append(meshObj.verts[f].co)
        TempGlob = GlobalPosition( LocVertsCo[compt], Obj)
        GloVertsCo.append(TempGlob)
        compt+=1
    return LocVertsCo, GloVertsCo



######################
######################
def Go():            #
                     #
######################
      global notObj, LenPointsSel, InitLocVerticesCo, InitGloVerticesCo, object, mesh, preSelectVertices
      global SelectVertices, GloVerticesCo, meshname, warn2


      try:

        SelectVertices = mesh.getVertsFromGroup('SelectedVerts',0)
        preSelectVertices = mesh.getVertsFromGroup('preSelectedVerts',0)


######################################################################################################
        if SelectVertices != []:
          preSelectVertices = mesh.removeVertsFromGroup('preSelectedVerts',preSelectVertices)
          preSelectVertices = mesh.assignVertsToGroup('preSelectedVerts',SelectVertices,0,"replace")
          preSelectVertices = mesh.getVertsFromGroup('preSelectedVerts',0)

          OkGo = "go"

          ## Recuperation des Coordonnees locale et global des points de la selection ###########

          LocVerticesCo, GloVerticesCo = InitialCoFromSelIndx(SelectVertices,mesh,object)


          InitLocVerticesCo = LocVerticesCo
          InitGloVerticesCo = GloVerticesCo


          ## Nombre de points selectionnes ##############
          LenPointsSel = len(SelectVertices)
          print LenPointsSel, " point(s) selectionne(s)."
          ###############################################

          #### Coordonnees globale pour un seule vertice ####
          #GloVertCo = GlobalPosition(LocVerticesCo[0], object)

          #### utiliser GloVertCo[0] pour coord X, etc... #####
          #print "coordonnees globale point1 : ",GloVertCo    #



          SelectVertices = mesh.removeVertsFromGroup('SelectedVerts',SelectVertices)

######################################################################################################

        if SelectVertices == []:
            print "ATTENTION vous n'avez pas assigne votre selection au Group 'SelectedVerts'!"
            OkGo = "Do not go"
            warn2 = 1

        return OkGo

      except:
        OkGo = "Do not go"
        return OkGo



######################
######################
def MainProg(x,y,z): #
                     #
######################
        global LocVerticesCo, InitLocVerticesCo, InitGloVerticesCo, SlidFromPoint, object, mesh
        global SlidGlobVal, preSelectVertices, SelectVertices
        global PointAxeX, PointAxeY, PointAxeZ, Offset
        tempVar=[]
        TGloVerticesCo=[]

        if SlidFromPoint.val > 0:
            NewValue = InitGloVerticesCo[SlidFromPoint.val-1][0+(PointAxeY.val == 1) + 2*(PointAxeZ.val == 1)]

            for n in range(0,len(GloVerticesCo)):
                offsX = InitGloVerticesCo[n][0] + NewValue
                offsY = InitGloVerticesCo[n][1] + NewValue
                offsZ = InitGloVerticesCo[n][2] + NewValue

                TGloVerticesCo = (InitGloVerticesCo[n][0] * (x == 0) + (NewValue * (x == 1)*(Offset.val == 0)) + ( offsX * (x == 1)*(Offset.val == 1)),InitGloVerticesCo[n][1] * (y == 0) + (NewValue * (y == 1) * (Offset.val == 0)) + ( offsY * (y == 1)*(Offset.val == 1)),InitGloVerticesCo[n][2] * (z == 0) + (NewValue * (z == 1) * (Offset.val == 0)) + ( offsZ * (z == 1)*(Offset.val == 1)))

                tempVar.append(TGloVerticesCo)
                locX, locY, locZ = LocalPosition(tempVar[n], object)

                mesh.verts[preSelectVertices[n]].co[0] = locX

                mesh.verts[preSelectVertices[n]].co[1] = locY

                mesh.verts[preSelectVertices[n]].co[2] = locZ

            NMesh.PutRaw(mesh,mesh.name)
            object.makeDisplayList()

        elif SlidFromPoint.val == 0:
            NewValue = SlidGlobVal.val

            for n in range(0,len(GloVerticesCo)):
                offsX = InitGloVerticesCo[n][0] + NewValue
                offsY = InitGloVerticesCo[n][1] + NewValue
                offsZ = InitGloVerticesCo[n][2] + NewValue

                TGloVerticesCo = (InitGloVerticesCo[n][0] * (x == 0) + (NewValue * (x == 1)*(Offset.val == 0)) + ( offsX * (x == 1)*(Offset.val == 1)),InitGloVerticesCo[n][1] * (y == 0) + (NewValue * (y == 1) * (Offset.val == 0)) + ( offsY * (y == 1)*(Offset.val == 1)),InitGloVerticesCo[n][2] * (z == 0) + (NewValue * (z == 1) * (Offset.val == 0)) + ( offsZ * (z == 1)*(Offset.val == 1)))

                tempVar.append(TGloVerticesCo)
                locX, locY, locZ = LocalPosition(tempVar[n], object)

                mesh.verts[preSelectVertices[n]].co[0] = locX

                mesh.verts[preSelectVertices[n]].co[1] = locY

                mesh.verts[preSelectVertices[n]].co[2] = locZ

            NMesh.PutRaw(mesh,mesh.name)
            object.makeDisplayList()



######################
######################
def draw():          #
                     #
######################
  global notObj, ecran, AxeX, AxeY, AxeZ, SlidFromPoint, warn, warn2
  global SlidGlobVal, lstep, PointAxeX, PointAxeY, PointAxeZ
  global LenPointsSel, GloVerticesCo, preSelectVertices, Offset

  color1 = (0.99, 0.99, 0.65)
  color2 = (0.567, 0.476, 0.365)
  color2Clear = (0.567, 0.476, 0.365, 1)
  color3 = (1.0, 1.0, 0.79)
  color4 = (0.265, 0.41, 0.4)
  color4Clear = (0.265, 0.41, 0.4, 1)
  color5 = (0.4, 0.472, 0.472)
  color6 = (0.5, 0.25, 0.25)
  color7 = (0.265, 0.4, 0.3)
  colorblack = (0.0, 0.0, 0.0)
  colorwhite = (1.0, 1.0, 1.0)
  colorred = (1.0, 0.0, 0.0)
  colorcyan = (0.0, 1.0, 1.0)
  colorgrey1 = (0.8, 0.8, 0.8)


  apply(glClearColor, color4Clear)

  glClear(GL_COLOR_BUFFER_BIT)

  apply(glColor3f, colorblack)
  glRecti(1, 1, 305, 285)
  apply(glColor3f, colorgrey1)
  glRecti(1, 1, 304, 286)
  apply(glColor3f, color7)
  glRecti(1, 1, 304, 285)




  apply(glColor3f, colorgrey1)
  glRecti(1, 280, 210, 252)
  apply(glColor3f, color6)
  glRecti(1, 280, 209, 253)
  apply(glColor3f, colorblack)
  glRecti(1, 280, 209, 279)

  apply(glColor3f, colorwhite)
  glRasterPos2f(10, 262)
  Text("ph_SetGlobalVal_V2_3")



                ######### ecran 0 ###################################
  if ecran == 0:

    apply(glColor3f,color3)
    glRasterPos2f(10, 226)
    Text("_________________")
    glRasterPos2f(10, 228)
    Text("Ce script vous sert a :")
    glRasterPos2f(10, 208)
    Text("1 :")
    glRasterPos2f(10, 191)
    Text("- Deplacer ou attribuer des valeurs globale")
    glRasterPos2f(10, 174)
    Text("   a votre selection de points.")
    glRasterPos2f(10, 153)
    Text("2 :")
    glRasterPos2f(10, 136)
    Text("- Realigner votre selection de points")
    glRasterPos2f(10, 119)
    Text("   sur un des points de cette meme selection.")


    if warn == 1:
        apply(glColor3f, colorgrey1)
        glRecti(114, 79, 248, 103)
        apply(glColor3f, colorblack)
        glRecti(115, 78, 248, 102)
        apply(glColor3f,(1.0, 0.0, 0.0))
        glRecti(115, 79, 247, 102)

        apply(glColor3f, color3)
        glRasterPos2f(120, 88)
        Text("Need a Mesh object !")

        warn = 0

    if warn2 == 1:
        apply(glColor3f, colorgrey1)
        glRecti(114, 79, 248, 103)
        apply(glColor3f, colorblack)
        glRecti(115, 78, 248, 102)
        apply(glColor3f,(1.0, 0.0, 0.0))
        glRecti(115, 79, 247, 102)

        apply(glColor3f, color3)
        glRasterPos2f(120, 88)
        Text("Assign selection first !")

        warn2 = 0



    Button("Go!", 2, 10, 45, 95, 25, "Start the main script")
    Button("CreateSelGroup", 3, 10, 80, 95, 25, "Create 2 group 'SelectedVerts' & 'preSelectedVerts'")
    Button("Exit", 1, 10, 10, 40, 25, "Quit !")

                ######### ecran 1 ###################################
  elif ecran == 1:

    Button("Apply", 8, 10, 10, 40, 25)

    apply(glColor3f,color3)
    glRasterPos2f(50, 197)
    Text("From Point #")

    SlidFromPoint = Number('', 4,130,190,80,24,SlidFromPoint.val,0,LenPointsSel)

    Offset = Toggle("Offset",4,164,45,46,78,Offset.val,"Use Offset displacement, or not.")


    apply(glColor3f,color3)
    glRasterPos2f(48, 139)
    Text("Global Value")

##################################
    if SlidFromPoint.val > 0:    #
        apply(glColor3f,color3)
        glRasterPos2f(57, 226)
        Text("Point index")

        apply(glColor3f, colorgrey1)
        glRecti(130, 219, 210, 242)
        apply(glColor3f, color5)
        glRecti(132, 221, 208, 240)

        apply(glColor3f, colorcyan)
        glRasterPos2f(133, 226)
        Text(str(preSelectVertices[SlidFromPoint.val-1]))

        apply(glColor3f,color3)
        glRasterPos2f(23, 168)
        Text("From Point's Axis")

        PointAxeX = Toggle("X",5,130,160,24,24,PointAxeX.val,"Get Value 'X' from Point#...")
        PointAxeY = Toggle("Y",6,158,160,24,24,PointAxeY.val,"Get Value 'Y' from Point#...")
        PointAxeZ = Toggle("Z",7,185,160,24,24,PointAxeZ.val,"Get Value 'Z' from Point#...")


        ######### Affiche coord. globale du point# sur l'Axe choisi #########
        apply(glColor3f, colorgrey1)
        glRecti(130, 130, 210, 153)
        apply(glColor3f, color3)
        glRecti(132, 132, 208, 151)

        apply(glColor3f, colorblack)
        glRasterPos2f(133, 137)

        if PointAxeX.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][0],3)))

        if PointAxeY.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][1],3)))

        if PointAxeZ.val == 1:
            Text(str(round(InitGloVerticesCo[SlidFromPoint.val-1][2],3)))

##################################
    elif SlidFromPoint.val == 0: #
        lstep=Number('limit ', 4,220,134, 80, 17,lstep.val,1.0,1000.0)
        SlidGlobVal = Number('', 4,130,130,80,24,SlidGlobVal.val,-lstep.val,lstep.val)


    #################################
    glColor3f(1.0, 0.0, 0.0)
    glRasterPos2f(75, 107)
    Text("Apply to")###### Apply to X ######

    glColor3f(0.0, 1.0, 0.0)
    glRasterPos2f(75, 80)
    Text("Apply to")###### Apply to Y ######

    glColor3f(0.4, 0.75, 1.0)
    glRasterPos2f(75, 53)
    Text("Apply to")###### Apply to Z ######

    AxeX = Toggle("X",4,130,99,24,24,AxeX.val,"Apply Global Value to X")
    AxeY = Toggle("Y",4,130,72,24,24,AxeY.val,"Apply Global Value to Y")
    AxeZ = Toggle("Z",4,130,45,24,24,AxeZ.val,"Apply Global Value to Z")


######################
######################
def event(evt, val): #
                     #
######################
    if ( evt == ESCKEY and not val): Exit()
    if (evt== QKEY and not val): Exit()



######################
######################
def bevent(evt):     #
                     #
######################
    global notObj, ecran, PointAxeX, PointAxeY, PointAxeZ
    global ApplyToX, ApplyToY, ApplyToZ, mesh, OkGo, InitGloVerticesCo
    global preSelectVertices, object, meshname, mesh, PrintedIndex
    global AxeX, AxeY, AxeZ, SlidFromPoint, Offset, SlidGlobVal, warn, warn2


    if   (evt== 1):
        Exit()

    elif (evt== 2):
        object,meshname,mesh = InfoObj()
        print "object = ",object
        if object != 1:
          CreateSelGroup()
          checkGo = Go()
          if checkGo == "go":
            print "Vous avez une selection"
            ecran = 1
            PrintedIndex = PrintIndex(preSelectVertices,InitGloVerticesCo,object,mesh)

        elif object == 1:
            warn = 1
            ecran = 0

        Blender.Window.Redraw()

    elif (evt== 3):
        object,meshname,mesh = InfoObj()
        print "object = ",object
        if object != 1:
            CreateSelGroup()
        elif object == 1:
            warn = 1
            ecran = 0
        Blender.Window.Redraw()

    elif (evt== 4):

        MainProg(AxeX.val,AxeY.val,AxeZ.val)

        Blender.Window.Redraw()

    elif (evt== 5):
        if PointAxeX.val == 0:
            PointAxeX.val = 1
        elif PointAxeX.val == 1:
            PointAxeY.val = 0
            PointAxeZ.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 6):
        if PointAxeY.val == 0:
            PointAxeY.val = 1
        elif PointAxeY.val == 1:
            PointAxeX.val = 0
            PointAxeZ.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 7):
        if PointAxeZ.val == 0:
            PointAxeZ.val = 1
        elif PointAxeZ.val == 1:
            PointAxeX.val = 0
            PointAxeY.val = 0
        MainProg(AxeX.val,AxeY.val,AxeZ.val)
        Blender.Window.Redraw()

    elif (evt== 8):
        object,meshname,mesh = InfoObj()
        DeleteObj(PrintedIndex)
        ecran = 0

        #### Reinitialisation ####
        AxeX.val = 0
        AxeY.val = 0
        AxeZ.val = 0
        SlidFromPoint.val = 0
        PointAxeX.val = 1
        PointAxeY.val = 0
        PointAxeZ.val = 0
        Offset.val = 0
        SlidGlobVal.val = 0.0

        Blender.Window.Redraw()

    elif warn == 1:
        notObj = 0
        warn = 0

    elif warn2 == 1:
        notObj = 0
        warn2 = 0

######################

Register(draw, event, bevent)